/*
	LUSScreenSaver
	Copyright (C) 2003-2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSScreenSaverApplet.h"
#include "LUSScreenSaverWidget.h"
#include "LUSScreenSaverMisc.h"
#include "LUSScreenSaver.h"

LUSScreenSaverApplet::LUSScreenSaverApplet()
	: m_pWidget(0), ref(0)
{
	DBG_LOG( "LUSScreenSaverApplet() > construct" );
}

LUSScreenSaverApplet::~LUSScreenSaverApplet()
{
	QWSServer::setScreenSaver( NULL );
	delete m_pWidget;
}

QWidget* LUSScreenSaverApplet::applet( QWidget* parent )
{
	if ( m_pWidget == NULL )
	{
		LUSScreenSaver* pSaver = new LUSScreenSaver;
		QWSServer::setScreenSaver( pSaver );
		DBG_LOG( "LUSScreenSaverApplet::applet() > QWSServer::setScreenSaver()" );
		m_pWidget = new LUSScreenSaverWidget( pSaver, parent );
		LUSMisc::InitWidget( m_pWidget );
	}
	return m_pWidget;
}

int LUSScreenSaverApplet::position() const
{
	return 6;
}

QRESULT LUSScreenSaverApplet::queryInterface( const QUuid& uuid, QUnknownInterface** iface )
{
	DBG_LOG( "LUSScreenSaverApplet::queryInterface() " );
	*iface = 0;
	if(uuid == IID_QUnknown)
	{
		*iface = this;
	}
	else if(uuid == IID_TaskbarApplet)
	{
		*iface = this;
	}

	if(*iface)
	{
		(*iface)->addRef();
	}
	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( LUSScreenSaverApplet )
}
