/*
	LUSScreenSaver
	Copyright (C) 2003-2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSScreenSaverMisc.h"
#include "LUSScreenSaverKeyFilter.h"

LUSKeyFilter::LUSKeyFilter()
{
}

LUSKeyFilter::~LUSKeyFilter()
{
}

void LUSKeyFilter::set()
{
	QWSServer::setKeyboardFilter( this );
}

void LUSKeyFilter::unset()
{
	QWSServer::setKeyboardFilter( NULL );
}

bool LUSKeyFilter::filter( int, int keycode, int, bool, bool )
{
	bool bRet = FALSE;
	
	if ( keycode == Qt::Key_F9		// Calender
		|| keycode == Qt::Key_F10	// Address
		|| keycode == Qt::Key_F11	// Menu
		|| keycode == Qt::Key_F12	// Home
		|| keycode == Qt::Key_F13	// Mail
		|| keycode == Qt::Key_F14	// Mail Check
		|| keycode == Qt::Key_F21	// double / single byte char select
		|| keycode == Qt::Key_F26	// KANA / HIRA select
		|| keycode == Qt::Key_F35	//
		|| keycode == 0x200d        // Sync
		|| ( keycode >= 0x2007 && keycode <= 0x2012 ) )		// special keys
	{
		bRet = TRUE;
	}

	return bRet;
}

