/*
	LUSScreenSaver
	Copyright (C) 2003-2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_MISC_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_MISC_H_

#include <qwidget.h>
#include <qstring.h>
#include <qdir.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qmessagebox.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/qpeapplication.h>
#include <qpe/config.h>
#include <qpe/power.h>
#include <qpe/resource.h>
#include <syslog.h>

#define	DBG_LOG( msg )	syslog( LOG_LOCAL3 | LOG_DEBUG,   "%s", msg )
#define	WRN_LOG( msg )	syslog( LOG_LOCAL3 | LOG_WARNING, "%s", msg )
#define	ERR_LOG( msg )	syslog( LOG_LOCAL3 | LOG_ERR,     "%s", msg )

namespace LUSMisc {

	enum {
		LUS_NOSAVE,
		LUS_SUSPEND,
		LUS_LIGHTOFF,
		LUS_SCREENSAVING
	};

	QString&	AppName();

	int		GetLightLevel();
	void	SetLightLevel( const int );
	int		GetDimLevel();
	int		GetLUSInterval();
	int		GetIconMode();
	void	SaveIconMode( int );

	bool	IsSuspendFirst();
	bool	IsACOnline();
	bool	IsDimEnable();
	bool	IsLightOffEnable();
	bool	IsSpecialAppExists( int );
	int		WhichIsFirst( int, int, int = -1 );
	int		GetInterval( int );

	QString	GetSaverName();
	QString	GetSaverLibPath();

	QString AbsSaverPath( const QString& );
	
	void InitWidget( QWidget* widget );

	QWidget* TaskBarWidget();

	bool IsPasswordEnable();
	bool IsLUSAuthInstalled();

	void SetKeyFilter();
	void UnsetKeyFilter();
}

#endif /* _LESS_UNSATICEFACTORY_SCREENSAVER_MISC_H_ */


